#!/usr/bin/perl -w

use strict;
use Bio::SeqIO;

my $db= $ARGV[0];
my $fas =  $ARGV[1];
my $out=$ARGV[2];

#my $fas = 'E:\Projects2\00V2.2\assembly\Ptrichocarpa_156.fa';

open (SRC,"$db");
my %scaffold2array =();
while (my $line=<SRC>){
	   chomp $line;
      my @temp=split(/\t/,$line);
      my $scaffold = $temp[0];
      if(not exists $scaffold2array{$scaffold}){
      	   my @buff=();
      	   push @buff,[@temp];
      	   $scaffold2array{$scaffold}=\@buff;
      }
      else{
      	   push @{$scaffold2array{$scaffold}},[@temp];
      }
}

open (TGT,">$out");


my $seq_obj = new Bio::SeqIO(-format => 'largefasta',                                   
                          -file   => $fas); 

while(my $pseq=$seq_obj->next_seq()){  
    my  $scaffold= $pseq->display_id;
     print $scaffold,"\n";
     
     if(not exists $scaffold2array{$scaffold}){
     	  next;
     }
     
     my @array = @{$scaffold2array{$scaffold}};
     for(@array){
     	  my @temp = @{$_};
     	 # my $loc = substr $temp[8],-16;
     	  my $loc = '';
     	  if($temp[8] =~ /Name\=(\S+)/){
     	  	 $loc = $1;
     	  }
     	  if($loc eq ''){
     	  	  next;
     	  }
     	  my $site1 = $temp[9];
     	  my $site2 = $temp[10];
          my $dire  = $temp[6];
          
         my $seq = $pseq->subseq($site1,$site2);   	
         
         if( $dire eq '-'){
         	   $seq=re_co($seq);
         }
         
         my $len = length($seq);
         
         ### only more than 50
         if($len >=50){
         	  print TGT ">$loc\n","$seq\n";
         }
     }

}




sub re_co
{
my $string="";
my $slen="";
my $temp;
my $stemp="";
my $sout="";

  $string=$_[0];
  $slen=length($string);

  for ($temp=0; $temp < $slen; $temp++) 
  {
    $stemp=substr ($string,$temp,1);
    $stemp= &com($stemp);
    $sout=$stemp.$sout;     
  }

return $sout;
1;
}
sub com
{
  my $in=$_[0];
  my $out;
  if    ($in eq "A"){$out="T";}
  elsif($in eq "T"){$out="A";}
  elsif($in eq "G"){$out="C";}
  elsif($in eq "C"){$out="G";}  
  else {$out='N';}
return $out;
1;  
}

