#!/usr/bin/perl -w

use strict;

my $sourcefile=$ARGV[0]; 
my $fas_fai   =$ARGV[1];
my $targetfile=$ARGV[2];

my $maxlen = 2000;


# scaffold length 

open(SRC1,"$fas_fai")||die "can not open file:";

my %scaffold2len = ();

while (my $line=<SRC1>){	
	  chomp $line; 
      my @temp=split(/\s+/,$line);
      $scaffold2len{$temp[0]} = $temp[1];
}



open(SRC,"$sourcefile")||die "can not open file:".$sourcefile;
open(TGT,">$targetfile")||die "can not write file:".$targetfile;

my %scaffold2array =();
while (my $line=<SRC>){
	   chomp $line;
      my @temp=split(/\t/,$line);
      my $scaffold = $temp[0];
      if(not exists $scaffold2array{$scaffold}){
      	   my @buff=();
      	   push @buff,[@temp];
      	   $scaffold2array{$scaffold} = \@buff;
      }
      else{
      	   push @{$scaffold2array{$scaffold}},[@temp];
      }
}


my ($star,$stop,$dis)=0;

for my $scaffold (sort keys %scaffold2array){
	my @pop_gff = @{$scaffold2array{$scaffold}};
	#print $scaffold,"\n";
	@pop_gff = sort{$a->[3] <=> $b->[3]}@pop_gff;
    @pop_gff = sort{$a->[0] cmp $b->[0]}@pop_gff;
    
     my @array = @pop_gff;
    
    
   # only one record
   if(@array==1){
   	    my $i=0;
   	    my $chr = $array[$i][0];   
   	    my $chr_len =  $scaffold2len{$chr};
   	    
   	   if($array[$i][6] eq '+'){		
			 $stop=$array[$i][3]-1;
			 
			 if(($array[$i][3]-1)> $maxlen){
			 	 $star = $stop-$maxlen+1;
			 }
			 else{
			     $star=1;
			 }
			 
		}
	    else{  ## -
			
		    $dis= $chr_len - $array[$i][4]-1;
		    $star=$array[$i][4]+1;
		     
		    if($dis > $maxlen){
		   	    $stop=$star+$maxlen-1;
		    }
		    else{
		        $stop = $chr_len;
		    }		   
	   }
	   
	   # modifty
	   if($star<1){
	   	   $star=1;
	   }
	   if($stop>$chr_len){
	   	   $stop=$chr_len;
	   }
	   if($stop<1){
	   	    $stop=1;
	   }
	   if($star>$stop){
	   	   $star=$stop;
	   }
	   

	     print TGT join("\t",@{$array[$i]}),"\t", $star,"\t",$stop,"\n";
	     next;
   } # only one
   
   
   	     # multiple lines 
   	     #---------------------------------------------------
     for(my $i=0; $i<(@array); $i++){
     	
	         my $chr = $array[$i][0];   
   	        my $chr_len =  $scaffold2len{$chr};
   	        	 #line 1
        if($i==0){
		   if($array[$i][6] eq '+'){		
			  $stop=$array[$i][3]-1;

			  if(($array[$i][3]-1)>$maxlen){
			 	 $star=$stop-$maxlen+1;
			  }
			  else{
			    $star=1;
			  }
			 
		   } 
		   else{   ### -
		      $dis=$array[$i+1][3]-$array[$i][4]-1;
		      $star=$array[$i][4]+1;
			  if($dis > $maxlen){
			 	  $stop=$star+$maxlen-1;
			  }
			  elsif($dis<500){
			      $stop=$star+500-1;
			  }
			  else{
			     $stop=$array[$i+1][3]-1;
			  } 		   
	      }
	   }
	
		 #last line
	   elsif($i==(@array-1)){
		   if($array[$i][6] eq '+'){
			  $dis  = $array[$i][3]-$array[$i-1][4]-1;
			  $stop = $array[$i][3]-1;
			  if($dis>$maxlen){
			 	  $star=$stop-$maxlen+1;
			  }
			  elsif($dis<500){
			      $star=$stop-500+1;
			  }
			  else{
			      $star=$array[$i-1][4]+1;
			  }	 
		   }
		   else{
		
		      $dis= $chr_len - $array[$i][4]-1;
		      $star=$array[$i][4]+1;
		      
		      if($dis > $maxlen){
		   	      $stop=$star+$maxlen-1;
		      }
		      else{
		          $stop = $chr_len;
		      }		   
	      }		
	  } #last line
	  else{
	  	  # other lines 
	  	  	 if($array[$i][6] eq '+'){
			    $dis= $array[$i][3]-$array[$i-1][4]-1;
			    $stop=$array[$i][3]-1;
			    
			    if($dis>$maxlen){
			 	    $star=$stop-$maxlen+1;
			    }
			    elsif($dis<500){
			        $star=$stop-500+1;
			    }
			    else{
			        $star=$array[$i-1][4]+1;
			    }	 
		    }
		    else{
		         $dis= $array[$i+1][3] - $array[$i][4]-1;
		         $star=$array[$i][4]+1;
			     if($dis>$maxlen){
			 	    $stop=$star+$maxlen-1;
			     }
			     elsif($dis<500){
			        $stop=$star+500-1;
			     }
			     else{
			        $stop=$array[$i+1][3]-1;
			     }		   
	        }	
	  } # other line
	  
	  	   # modifty
	   if($star<1){
	   	   $star=1;
	   }
	   if($stop>$chr_len){
	   	   $stop=$chr_len;
	   }
	   if($stop<1){
	   	    $stop=1;
	   }
	   if($star>$stop){
	   	   $star=$stop;
	   }
	   

      print TGT join("\t",@{$array[$i]}),"\t", $star,"\t",$stop,"\n";
      
     }#  for $i
} # each scaffold  
    
